/** @jsx React.DOM */
var post = new Mutant({
	id: 0,
	title: "",
	content: ""
});
var comments = new Mutant({
	comments: []
});

var App = React.createClass({
	defaultProps: function () {
		return {
			post: {
				id: 0,
				title: "",
				content: ""
			},
			comments: {
				comments: []
			}
		}
	},
	propTypes: {
		post: React.PropTypes.shape({
			id: React.PropTypes.number,
			title: React.PropTypes.string,
			content: React.PropTypes.string,
			mutant: React.PropTypes.instanceOf(Mutant)
		}),
		comments: React.PropTypes.shape({
			comments: React.PropTypes.array,
			mutant: React.PropTypes.instanceOf(Mutant)
		})
	},
	render: function () {
		return (
			<div className="app">
				<Post {...this.props.post} />
				<Comments {...this.props.comments} />
			</div>
		);
	}
});

var Post = React.createClass({
	render: function () {
		return (
			<div className="post">
				<h1>{this.props.post}</h1>
				<p>{this.props.content}</p>
			</div>
		);
	}
});

var Comments = React.createClass({
	render: function () {
		var comments = this.props.comments || [];
		var list = comments.map(function (comment) {
			return <Comment {...comment} />
		});
		return (
			<div className="comments">
				{list}
			</div>
		);
	}
});

var Comment = React.createClass({
	propTypes: {
		username: React.PropTypes.string,
		date: React.PropTypes.date,
		comment: React.PropTypes.string
	},
	render: function () {
		return (
			<div className="comment">
				<div>{this.props.username}</div>
				<div>{this.props.date}</div>
				<div>{this.props.comment}</div>
			</div>
		);
	}
});